> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://help.sigmacomputing.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://help.sigmacomputing.com/_mcp/server.

# List workbook sources

GET https://api.sigmacomputing.com/v2/workbooks/{workbookId}/sources

Get the data sources of a workbook given the workbookId. The response can be a dataset (deprecated), table, custom SQL element, or the data model document and specific elements used as a source.

  ### Usage notes
  - Retrieve the **workbookId** by calling the [/v2/workbooks](https://help.sigmacomputing.com/reference/list-workbooks) endpoint.

Reference: https://help.sigmacomputing.com/reference/get-workbook-sources

## OpenAPI Specification

```yaml
openapi: 3.1.0
info:
  title: sigma-rest-api
  version: 1.0.0
paths:
  /v2/workbooks/{workbookId}/sources:
    get:
      operationId: getWorkbookSources
      summary: List workbook sources
      description: >-
        Get the data sources of a workbook given the workbookId. The response
        can be a dataset (deprecated), table, custom SQL element, or the data
        model document and specific elements used as a source.

          ### Usage notes
          - Retrieve the **workbookId** by calling the [/v2/workbooks](https://help.sigmacomputing.com/reference/list-workbooks) endpoint.
      tags:
        - Workbooks
      parameters:
        - name: workbookId
          in: path
          required: true
          schema:
            type: string
        - name: Authorization
          in: header
          description: OAuth authentication
          required: true
          schema:
            type: string
      responses:
        '200':
          description: The response body.
          content:
            application/json:
              schema:
                type: array
                items:
                  $ref: >-
                    #/components/schemas/V2WorkbooksWorkbookIdSourcesGetResponsesContentApplicationJsonSchemaItems
servers:
  - url: https://api.sigmacomputing.com
    description: Server for GCP (US) hosted organizations
  - url: https://api.sa.gcp.sigmacomputing.com
    description: Server for GCP (KSA) hosted organizations
  - url: https://aws-api.sigmacomputing.com
    description: Server for AWS US (West) hosted organizations
  - url: https://api.us-a.aws.sigmacomputing.com
    description: Server for AWS US (East) hosted organizations
  - url: https://api.ca.aws.sigmacomputing.com
    description: Server for AWS Canada hosted organizations
  - url: https://api.eu.aws.sigmacomputing.com
    description: Server for AWS Europe hosted organizations
  - url: https://api.au.aws.sigmacomputing.com
    description: Server for AWS Australia and APAC hosted organizations
  - url: https://api.uk.aws.sigmacomputing.com
    description: Server for AWS UK hosted organizations
  - url: https://api.us.azure.sigmacomputing.com
    description: Server for Azure US hosted organizations
  - url: https://api.eu.azure.sigmacomputing.com
    description: Server for Azure Europe hosted organizations
  - url: https://api.ca.azure.sigmacomputing.com
    description: Server for Azure Canada hosted organizations
  - url: https://api.uk.azure.sigmacomputing.com
    description: Server for Azure United Kingdom hosted organizations
  - url: https://api.au.azure.sigmacomputing.com
    description: Server for Azure Australia hosted organizations
components:
  schemas:
    V2WorkbooksWorkbookIdSourcesGetResponsesContentApplicationJsonSchemaItemsOneOf0Type:
      type: string
      enum:
        - data-model
      title: >-
        V2WorkbooksWorkbookIdSourcesGetResponsesContentApplicationJsonSchemaItemsOneOf0Type
    V2WorkbooksWorkbookIdSourcesGetResponsesContentApplicationJsonSchemaItems0:
      type: object
      properties:
        type:
          $ref: >-
            #/components/schemas/V2WorkbooksWorkbookIdSourcesGetResponsesContentApplicationJsonSchemaItemsOneOf0Type
        dataModelId:
          type: string
        elementIds:
          type: array
          items:
            type: string
        versionTagId:
          type: string
      required:
        - type
        - dataModelId
        - elementIds
      title: >-
        V2WorkbooksWorkbookIdSourcesGetResponsesContentApplicationJsonSchemaItems0
    V2WorkbooksWorkbookIdSourcesGetResponsesContentApplicationJsonSchemaItemsOneOf1Type:
      type: string
      enum:
        - dataset
      description: Dataset (deprecated)
      title: >-
        V2WorkbooksWorkbookIdSourcesGetResponsesContentApplicationJsonSchemaItemsOneOf1Type
    V2WorkbooksWorkbookIdSourcesGetResponsesContentApplicationJsonSchemaItems1:
      type: object
      properties:
        type:
          $ref: >-
            #/components/schemas/V2WorkbooksWorkbookIdSourcesGetResponsesContentApplicationJsonSchemaItemsOneOf1Type
          description: Dataset (deprecated)
        inodeId:
          type: string
        url:
          type: string
          description: URL to open this dataset in Sigma.
      required:
        - type
        - inodeId
        - url
      title: >-
        V2WorkbooksWorkbookIdSourcesGetResponsesContentApplicationJsonSchemaItems1
    V2WorkbooksWorkbookIdSourcesGetResponsesContentApplicationJsonSchemaItemsOneOf2Type:
      type: string
      enum:
        - table
      title: >-
        V2WorkbooksWorkbookIdSourcesGetResponsesContentApplicationJsonSchemaItemsOneOf2Type
    V2WorkbooksWorkbookIdSourcesGetResponsesContentApplicationJsonSchemaItems2:
      type: object
      properties:
        type:
          $ref: >-
            #/components/schemas/V2WorkbooksWorkbookIdSourcesGetResponsesContentApplicationJsonSchemaItemsOneOf2Type
        inodeId:
          type: string
      required:
        - type
        - inodeId
      title: >-
        V2WorkbooksWorkbookIdSourcesGetResponsesContentApplicationJsonSchemaItems2
    V2WorkbooksWorkbookIdSourcesGetResponsesContentApplicationJsonSchemaItemsOneOf3Type:
      type: string
      enum:
        - custom-sql
      title: >-
        V2WorkbooksWorkbookIdSourcesGetResponsesContentApplicationJsonSchemaItemsOneOf3Type
    V2WorkbooksWorkbookIdSourcesGetResponsesContentApplicationJsonSchemaItems3:
      type: object
      properties:
        type:
          $ref: >-
            #/components/schemas/V2WorkbooksWorkbookIdSourcesGetResponsesContentApplicationJsonSchemaItemsOneOf3Type
        connectionId:
          type: string
          description: ID of the connection where the custom SQL element is run.
        definition:
          type: string
          description: Raw SQL definition for the custom SQL element.
        customSqlId:
          type: string
          description: Element ID of the custom SQL.
      required:
        - type
        - connectionId
        - definition
        - customSqlId
      title: >-
        V2WorkbooksWorkbookIdSourcesGetResponsesContentApplicationJsonSchemaItems3
    V2WorkbooksWorkbookIdSourcesGetResponsesContentApplicationJsonSchemaItems:
      oneOf:
        - $ref: >-
            #/components/schemas/V2WorkbooksWorkbookIdSourcesGetResponsesContentApplicationJsonSchemaItems0
        - $ref: >-
            #/components/schemas/V2WorkbooksWorkbookIdSourcesGetResponsesContentApplicationJsonSchemaItems1
        - $ref: >-
            #/components/schemas/V2WorkbooksWorkbookIdSourcesGetResponsesContentApplicationJsonSchemaItems2
        - $ref: >-
            #/components/schemas/V2WorkbooksWorkbookIdSourcesGetResponsesContentApplicationJsonSchemaItems3
      title: >-
        V2WorkbooksWorkbookIdSourcesGetResponsesContentApplicationJsonSchemaItems
  securitySchemes:
    OAuth:
      type: http
      scheme: bearer
      description: OAuth 2.0 authentication

```

## Examples



**Request**

```json
{}
```

**Response**

```json
[
  {
    "dataModelId": "dm_8f3a2c1b9e7d4f2a",
    "elementIds": [
      "elem_4b7d9f2c1a3e5d6f",
      "elem_9a1c3e7b5d4f2a8b"
    ],
    "type": "data-model",
    "versionTagId": "vtag_202406"
  }
]
```

**SDK Code**

```python
import requests

url = "https://api.sigmacomputing.com/v2/workbooks/workbookId/sources"

payload = {}
headers = {
    "Authorization": "<token>.",
    "Content-Type": "application/json"
}

response = requests.get(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://api.sigmacomputing.com/v2/workbooks/workbookId/sources';
const options = {
  method: 'GET',
  headers: {Authorization: '<token>.', 'Content-Type': 'application/json'},
  body: '{}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.sigmacomputing.com/v2/workbooks/workbookId/sources"

	payload := strings.NewReader("{}")

	req, _ := http.NewRequest("GET", url, payload)

	req.Header.Add("Authorization", "<token>.")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.sigmacomputing.com/v2/workbooks/workbookId/sources")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Get.new(url)
request["Authorization"] = '<token>.'
request["Content-Type"] = 'application/json'
request.body = "{}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.get("https://api.sigmacomputing.com/v2/workbooks/workbookId/sources")
  .header("Authorization", "<token>.")
  .header("Content-Type", "application/json")
  .body("{}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('GET', 'https://api.sigmacomputing.com/v2/workbooks/workbookId/sources', [
  'body' => '{}',
  'headers' => [
    'Authorization' => '<token>.',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.sigmacomputing.com/v2/workbooks/workbookId/sources");
var request = new RestRequest(Method.GET);
request.AddHeader("Authorization", "<token>.");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "Authorization": "<token>.",
  "Content-Type": "application/json"
]
let parameters = [] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.sigmacomputing.com/v2/workbooks/workbookId/sources")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "GET"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```